export declare function isIndex(value: any, length?: number): boolean;
export declare function isObject(value: any): boolean;
/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
export declare function stringToPath(string: string): any[];
/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
export declare function isKey(value: any, object: any): boolean;
